// $Revision: 1.1 $

using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Windows.Forms;
using System.Xml.Serialization;

namespace WIL.GDI
{
	#region 萔.

	/// <summary>
	/// GDI}`ҏW[h
	/// </summary>
	public enum FigureHandlingMode
	{
		/// <summary>ړƃTCYύX</summary>
		Normal,
		/// <summary>]</summary>
		Rotate
	}

	#endregion

	#region \.

	/// <summary>
	/// L[{[h\
	/// </summary>
	public struct KeyboardInfo
	{
		/// <summary>
		/// . 
		/// </summary>
		public bool IsDown;

		/// <summary>
		/// ĂL[.
		/// </summary>
		public bool Alt;
		
		/// <summary>
		/// ĂL[.
		/// </summary>
		public bool Control;
		
		/// <summary>
		/// ĂL[.
		/// </summary>
		public bool Shift;
		
		/// <summary>
		/// ĂL[.
		/// </summary>
		public Keys KeyCode;
		
		/// <summary>
		/// ĂL[.
		/// </summary>
		public Keys KeyData;
		
		/// <summary>
		/// ĂL[.
		/// </summary>
		public int KeyValue;
	};

	/// <summary>
	/// }EX{^̋`̈̏ 
	/// </summary>
	public struct MouseInfo
	{
		/// <summary>
		/// Obv.
		/// </summary>
		public bool bGrip;
		
		/// <summary>
		/// Obvʒu.
		/// </summary>
		public int iGripPosition;

		/// <summary>
		/// }EX|C^ʒu.
		/// </summary>
		public FVIL.Data.CFviPoint mouse;

		/// <summary>
		/// Iꂽ}`.
		/// </summary>
		public FVIL.GDI.CFviGdiFigure figure;
		
		/// <summary>
		/// {^̐}`ʒu.
		/// </summary>
		public FVIL.Data.CFviPoint position;
		
		/// <summary>
		/// {^̐}`̋@.
		/// </summary>
		public FVIL.Data.CFviPoint axis;
		
		/// <summary>
		/// {^̐}`̉]p.
		/// </summary>
		public FVIL.Data.CFviAngle angle;

		/// <summary>
		/// {^̐}`̊Oڋ`.
		/// </summary>
		public FVIL.Data.CFviRectangle clip;
	};

	#endregion

	#region C^[tF[X.

	/// <summary>
	/// }EXő삷GDI}`̃C^[tF[X
	/// </summary>
	public interface IFigureHandling
	{
		/// <summary>
		/// }EXJ[\̌`ύX۔
		/// </summary>
		/// <param name="sender">}EXCxgRg[</param>
		/// <param name="e">}EXCxg</param>
		/// <param name="iGripPosition">}EXŒ͂܂ꂽʒu</param>
		void ChangeCursor(System.Object sender, System.Windows.Forms.MouseEventArgs e, int iGripPosition);

		/// <summary>
		/// }`̕ҏW
		/// </summary>
		/// <param name="current">݂̃}EXʒu</param>
		/// <param name="info">{^̏</param>
		/// <param name="key">{^̃L[{[h</param>
		/// <returns>
		///		}`̕ҏWsꂽꍇ true Ԃ܂B
		///		sȂꍇ false Ԃ܂B
		/// </returns>
		bool ModifyFigure(FVIL.Data.CFviPoint current, MouseInfo info, KeyboardInfo key);
	};

	#endregion

	/// <summary>
	/// GDI}`}EXő삷I[oC
	/// </summary>
	/// <remarks>
	///		}`̈ړTCYύX}EXő삷邽߂̃I[oCłB
	/// </remarks>
	public class FigureOverlay : FVIL.GDI.CFviOverlay
	{
		/// <summary>
		/// RXgN^p֐
		/// </summary>
		private void _Constructor()
		{
			#region L[{[h̏.
			m_KeyboardInfo.IsDown = false;
			m_KeyboardInfo.Alt = false;
			m_KeyboardInfo.Control = false;
			m_KeyboardInfo.Shift = false;
			m_KeyboardInfo.KeyCode = Keys.None;
			m_KeyboardInfo.KeyData = Keys.None;
			m_KeyboardInfo.KeyValue = 0;
			#endregion

			#region }EX{^̏.
			m_MouseInfo.bGrip = false;
			m_MouseInfo.iGripPosition = 0;
			m_MouseInfo.figure = null;
			#endregion
		}

		/// <summary>
		/// RXgN^
		/// </summary>
		public FigureOverlay()
		{
			_Constructor();
		}

		/// <summary>
		/// RXgN^
		/// </summary>
		/// <param name="bMove">}EXɂ}`̈ړ̋</param>
		/// <param name="bModify">}EXɂ}`̕ҏW̋</param>
		/// <param name="bRoate">}EXɂ}`̉]̋</param>
		public FigureOverlay(bool bMove, bool bModify, bool bRoate)
		{
			_Constructor();
			EnableMove = bMove;
			EnableModify = bModify;
			EnableRotate = bRoate;
		}

		/// <summary>
		/// L[{[h̏
		/// </summary>
		[XmlIgnore]
		[Browsable(false)]
		[Category("t")]
		[Description("L[{[h̏ێĂ܂B")]
		public virtual KeyboardInfo KeyboardInfo
		{
			get { return m_KeyboardInfo; }
			set { m_KeyboardInfo = value; }
		}
		private KeyboardInfo m_KeyboardInfo = new KeyboardInfo();

		/// <summary>
		/// }EX{^̏ 
		/// </summary>
		[XmlIgnore]
		[Browsable(false)]
		[Category("t")]
		[Description("}EX{^̏ێĂ܂B")]
		public virtual MouseInfo MouseInfo
		{
			get { return m_MouseInfo; }
			set { m_MouseInfo = value; }
		}
		private MouseInfo m_MouseInfo = new MouseInfo();

		/// <summary>
		/// }`ҏW[h
		/// </summary>
		[XmlIgnore]
		[Category("[h")]
		[Description("}`̑샂[hwtOłB")]
		public virtual FigureHandlingMode HandlingMode
		{
			get { return m_HandlingMode; }
			set { m_HandlingMode = value; }
		}
		private FigureHandlingMode m_HandlingMode = FigureHandlingMode.Normal;

		/// <summary>
		/// }`ҏW[h (ړ)
		/// </summary>
		[XmlIgnore]
		[Category("[h")]
		[Description("}EXɂ}`̈ړtOłB")]
		public virtual bool EnableMove
		{
			get { return m_EnableMove; }
			set { m_EnableMove = value; }
		}
		private bool m_EnableMove = true;

		/// <summary>
		/// }`ҏW[h (ҏW)
		/// </summary>
		[XmlIgnore]
		[Category("[h")]
		[Description("}EXɂ}`̕ҏWtOłB")]
		public virtual bool EnableModify
		{
			get { return m_EnableModify; }
			set { m_EnableModify = value; }
		}
		private bool m_EnableModify = true;

		/// <summary>
		/// }`ҏW[h (])
		/// </summary>
		[XmlIgnore]
		[Category("[h")]
		[Description("}EXɂ}`̉]tOłB")]
		public virtual bool EnableRotate
		{
			get { return m_EnableRotate; }
			set { m_EnableRotate = value; }
		}
		private bool m_EnableRotate = true;

		/// <summary>
		/// }`̎擾 (I𑮐w)
		/// </summary>
		/// <param name="select">I𑮐</param>
		/// <returns>
		///		w肳ꂽI𑮐ƈv}`Ԃ܂B
		///		Ȃ null Ԃ܂B
		/// </returns>
		public virtual FVIL.GDI.CFviGdiFigure GetSelectedFigure(bool select)
		{
			// z̖(y̑O)珈.
			for (int i = Figures.Count - 1; i >= 0; i--)
			{
				FVIL.GDI.CFviGdiFigure figure = Figures[i];
				if (figure.Select == select) return figure;
			}
			return null;
		}
		
		/// <summary>
		/// }`̎擾 (ʒuw)
		/// </summary>
		/// <param name="x">wʒuX (NCAgW)</param>
		/// <param name="y">wʒuY (NCAgW)</param>
		/// <returns>
		///		wʒuɂ}`Ԃ܂B
		///		Ȃ null Ԃ܂B
		/// </returns>
		public virtual FVIL.GDI.CFviGdiFigure GetFigure(int x, int y)
		{
			return GetFigure(new Point(x, y));
		}

		/// <summary>
		/// }`̎擾 (ʒuw)
		/// </summary>
		/// <param name="location">wʒu (NCAgW)</param>
		/// <returns>
		///		wʒuɂ}`Ԃ܂B
		///		Ȃ null Ԃ܂B
		/// </returns>
		public virtual FVIL.GDI.CFviGdiFigure GetFigure(Point location)
		{
			// ViewNCAg̈ł̍W.
			// Scaling = true ̎́A摜Wɕϊ.
			FVIL.Data.CFviPoint position = (Scaling)
				? DPtoIP(location, ScalingMode)
				: new FVIL.Data.CFviPoint(location);

			// z̖(y̑O)珈.
			for (int i = Figures.Count - 1; i >= 0; i--)
			{
				FVIL.GDI.CFviGdiFigure figure = Figures[i];
				double margin = (Scaling) ? 4 / Magnification : 4;
				int iGripPosition = figure.CheckFocusMarkPosition(position, margin);
				if (iGripPosition != 0) return figure;
			}
			return null;
		}

		/// <summary>
		/// 
		/// </summary>
		/// <param name="src"></param>
		/// <returns>
		///		w肳ꂽNX^̃N[𐶐ĕԂ܂B
		///		wf̃NX^x Clone ́Ał Shallow Copy ̂ŔzvfPP Deep Copy ܂B
		///		vfwf̃NX^xłȂ Clone \bhŃN[𐶐܂B
		///		vfwf̃NX^x̏ꍇ́AX DeepCopy s܂B
		/// </returns>
		public static FVIL.GDI.CFviGdiCluster DeepCopy(FVIL.GDI.CFviGdiCluster src)
		{
			FVIL.GDI.CFviGdiCluster clone = (FVIL.GDI.CFviGdiCluster)src.Clone();
			for (int i=0 ; i<src.Figures.Count ; i++)
			{
				FVIL.GDI.CFviGdiFigure item = src.Figures[i];

				// wf̃NX^x̔ typeof ōs܂.
				// is L[[h CFviGdiCluster ̔hNXΏۂɂȂ̂ŒӂKvł.
				if (item.GetType() == typeof(FVIL.GDI.CFviGdiCluster))
					clone.Figures[i] = DeepCopy((FVIL.GDI.CFviGdiCluster)item);
				else
					clone.Figures[i] = (FVIL.GDI.CFviGdiFigure)item.Clone();
			}
			return clone;
		}

		/// <summary>
		/// g̐̕ (pK{)
		/// </summary>
		/// <returns>
		///		g̃CX^X̕Ԃ܂B
		/// </returns>
		public override System.Object Clone()
		{
			WIL.GDI.FigureOverlay clone = new WIL.GDI.FigureOverlay();
			clone.CopyFrom( this );
			return clone;
		}

		/// <summary>
		/// CX^X̕ (pK{)
		/// </summary>
		/// <param name="src"></param>
		/// <returns>
		///		̎g̃CX^XԂ܂B
		/// </returns>
		/// <remarks>
		///		{NX CopyFrom ́AFigures z̐}`̃CX^X Shallow Rs[܂B
		///		̏ꍇ́Aƕ̃I[oCœ̃CX^XۗL邱ƂɂȂ܂B
		///		 Deep Rs[(CX^X̃Rs[łȂAe𕡐邱)ꍇ́A
		///		L̂悤 CopyFigures I[o[ChĂB
		///		{NX CopyFrom ́ACX^X Shallow Rs[sO CopyFigures Ăяo܂B
		/// </remarks>
		public override System.Object CopyFrom(System.Object src)
		{
			base.CopyFrom(src);
			return this;
		}

#if false	// TODO: Ǝ̐}`sꍇ́ÃfBNeBuLɂĂ.
		/// <summary>
		/// Ǝ̐}`
		/// </summary>
		/// <param name="src"></param>
		public override void CopyFigures(FVIL.GDI.CFviOverlay src)
		{
			WIL.GDI.FigureOverlay _src = (WIL.GDI.FigureOverlay)src;

			// TODO: ŕsĂ.
		}
#endif

		/// <summary>
		/// nbVR[h̐ (pK{)
		/// </summary>
		/// <returns></returns>
		public override int GetHashCode()
		{
			return base.GetHashCode();
		}

		/// <summary>
		/// CX^X̓er (pK{)
		/// </summary>
		/// <param name="src">rΏ</param>
		/// <returns>
		///		vꍇ true AvȂꍇ false Ԃ܂B
		/// </returns>
		public override bool Equals(object src)
		{
			if (ReferenceEquals(src, null)) return false;

			try
			{
				WIL.GDI.FigureOverlay _src = (WIL.GDI.FigureOverlay)src;

				// TODO: Ǝ̔rꍇ́AōsĂ.

				return base.Equals(src);
			}
			catch(System.Exception)
			{
				return false;
			}
		}

		/// <summary>
		/// rIy[^ ()
		/// </summary>
		/// <param name="ope1">Ӓl</param>
		/// <param name="ope2">EӒl</param>
		/// <returns>
		///		vꍇ true AvȂꍇ false Ԃ܂B
		/// </returns>
		public static bool operator ==(WIL.GDI.FigureOverlay ope1, WIL.GDI.FigureOverlay ope2)
		{
			if (ReferenceEquals(ope1, null))
				return ReferenceEquals(ope2, null);
			return ope1.Equals(ope2);
		}

		/// <summary>
		/// rIy[^ (s)
		/// </summary>
		/// <param name="ope1">Ӓl</param>
		/// <param name="ope2">EӒl</param>
		/// <returns>
		///		vꍇ false AvȂꍇ true Ԃ܂B
		/// </returns>
		public static bool operator !=(WIL.GDI.FigureOverlay ope1, WIL.GDI.FigureOverlay ope2)
		{
			return !(ope1 == ope2);
		}

		/// <summary>
		/// `揈
		/// </summary>
		/// <param name="hdc">`̃foCXReLXg</param>
		/// <param name="region">`͈</param>
		/// <returns>
		///		`悳ꂽ}`̌Ԃ܂B
		/// </returns>
		public override int Play(System.IntPtr hdc, System.Drawing.Rectangle region)
		{
			if (!Enable && !Active) return 0;
			int iCount = base.Play(hdc, region);
			return iCount;
		}

		/// <summary>
		/// }EXCxgnh̓o^
		/// </summary>
		/// <param name="control"></param>
		public override void AddMouseEventHandler(System.Windows.Forms.Control control)
		{
			control.KeyDown += new System.Windows.Forms.KeyEventHandler(OnKeyDown);
			control.KeyUp += new System.Windows.Forms.KeyEventHandler(OnKeyUp);
			control.PreviewKeyDown += new System.Windows.Forms.PreviewKeyDownEventHandler(OnPreviewKeyDown);
			control.MouseDown += new System.Windows.Forms.MouseEventHandler(OnMouseDown);
			control.MouseMove += new System.Windows.Forms.MouseEventHandler(OnMouseMove);
			control.MouseUp	+= new System.Windows.Forms.MouseEventHandler(OnMouseUp);
			control.MouseLeave += new System.EventHandler(OnMouseLeave);
		}

		/// <summary>
		/// }EXCxgnh̉
		/// </summary>
		/// <param name="control"></param>
		public override void DelMouseEventHandler(System.Windows.Forms.Control control)
		{
			control.KeyDown -= new System.Windows.Forms.KeyEventHandler(OnKeyDown);
			control.KeyUp -= new System.Windows.Forms.KeyEventHandler(OnKeyUp);
			control.PreviewKeyDown -= new System.Windows.Forms.PreviewKeyDownEventHandler(OnPreviewKeyDown);
			control.MouseDown -= new System.Windows.Forms.MouseEventHandler(OnMouseDown);
			control.MouseMove -= new System.Windows.Forms.MouseEventHandler(OnMouseMove);
			control.MouseUp	-= new System.Windows.Forms.MouseEventHandler(OnMouseUp);
			control.MouseLeave -= new System.EventHandler(OnMouseLeave);
		}

		/// <summary>
		/// }EXObv۔
		/// </summary>
		/// <param name="sender">}EXCxgRg[</param>
		/// <param name="e">}EXCxg</param>
		/// <param name="AllowGrip">ObvXe[^X</param>
		public override void CanMouseGrip(System.Object sender, System.Windows.Forms.MouseEventArgs e, ref bool AllowGrip)
		{
			if (!Active) return;	// Ȃ.
			if (!AllowGrip) return;	// ObvĂȂ.

			try
			{
				if (m_MouseInfo.bGrip == false)
				{
					// }`̑I𑮐ύXꂽtO.
					bool bSelectedStatusChanged = false;

					FVIL.Data.CFviPoint position = (Scaling)
						? DPtoIP(e.Location, ScalingMode)
						: new FVIL.Data.CFviPoint(e.Location);

					#region z̖(y̑O)珈.
					for (int i = Figures.Count - 1; i >= 0; i--)
					{
						FVIL.GDI.CFviGdiFigure figure = Figures[i];
						if (!figure.Enable) continue;

						double margin = (Scaling) ? 4 / Magnification : 4;
						int iGripPosition = figure.CheckFocusMarkPosition(position, margin);
						if (iGripPosition != 0)
						{
							// I𑮐̕ύX.
							if (figure.Select == true)
							{
								if (m_KeyboardInfo.IsDown &&
									m_KeyboardInfo.Control == false &&
									m_KeyboardInfo.Alt == false &&
									m_KeyboardInfo.Shift == true)
								{
									// SHIFT Ă.
									figure.Select = false;
									bSelectedStatusChanged = true;
									break;
								}
							}
							else
							{
								figure.Select = true;
								bSelectedStatusChanged = true;
							}

							#region (!) p`ɑ΂bIȏu.
							if (figure is FVIL.GDI.CFviGdiPolyline)
							{
								// CFviGdiPolyline  Close ̂Ƃ_Ŕ鏈u.
								// XbhZ[tł͂Ȃ̂Œ.
								// {́Ap CheckFocusMarkPosition I[o[Chׂ.

								FVIL.GDI.CFviGdiPolyline _figure = (FVIL.GDI.CFviGdiPolyline)figure;
								if (_figure.Close)
								{
									_figure.Close = false;
									int iGripVetex = _figure.CheckFocusMarkPosition(position, margin);
									_figure.Close = true;
									// _܂͕ӈȊOŊOڋ`̂Ƃ͈ړ(-1)Ƃ.
									iGripPosition = (iGripVetex != 0) ? iGripVetex : -1;
								}
							}
							#endregion

							// ViewNCAg̈ł̍W.
							// Scaling = true ̎́A摜Wɕϊ.
							FVIL.Data.CFviPoint mouse = (Scaling)
								? DPtoIP(e.Location, ScalingMode)
								: new FVIL.Data.CFviPoint(e.Location);

							#region ObvʒuƐ}`̏Ԃێ.
							m_MouseInfo.bGrip = true;
							m_MouseInfo.iGripPosition = iGripPosition;
							m_MouseInfo.mouse = mouse;
							m_MouseInfo.figure = figure;
							m_MouseInfo.position = figure.Position;
							m_MouseInfo.axis = figure.Axis;
							m_MouseInfo.angle = figure.Angle;
							m_MouseInfo.clip = figure.GetClipRect();
							Validate(ref m_MouseInfo);		// L.
							#endregion

							break;
						}
					}
					#endregion

					// I𑮐̐؂ւ.
					if (m_KeyboardInfo.IsDown &&
						m_KeyboardInfo.Control == false &&
						m_KeyboardInfo.Alt == false &&
						m_KeyboardInfo.Shift == true)
					{
						// SHIFT ĂƂ.
					}
					else
					{
						// SHIFT ĂȂƂ.

						if (m_MouseInfo.bGrip == false)
						{
							#region ͂܂Ȃꍇ́ASăZbg.
							m_MouseInfo.figure = null;
							for (int i = Figures.Count - 1; i >= 0; i--)
							{
								FVIL.GDI.CFviGdiFigure figure = Figures[i];
								figure.Select = false;
							}
							#endregion
						}
						else if (bSelectedStatusChanged)
						{
							#region I𑮐ɕωƂ́ArIɃZbg.
							for (int i = Figures.Count - 1; i >= 0; i--)
							{
								FVIL.GDI.CFviGdiFigure figure = Figures[i];
								if (ReferenceEquals(figure, m_MouseInfo.figure))
									figure.Select = true;
								else
									figure.Select = false;
							}
							#endregion
						}
					}
				}

				// ȍ~ÃI[oCł̃ObvȂ.
				if (m_MouseInfo.bGrip == true)
				{
					AllowGrip = false;
				}
			}
			catch (System.Exception)
			{
			}
			return;
		}

		/// <summary>
		/// }EXJ[\̌`ύX۔
		/// </summary>
		/// <param name="sender">}EXCxgRg[</param>
		/// <param name="e">}EXCxg</param>
		/// <param name="AllowChange">J[\ύXXe[^X</param>
		public override void CanChangeCursor(System.Object sender, System.Windows.Forms.MouseEventArgs e, ref bool AllowChange)
		{
			if (!Active) return;		// Ȃ.
			if (!AllowChange) return;	// J[\ύXĂȂ.

			// sender ܂ e ȏꍇ͖.
			if (ReferenceEquals(sender, null)) return;
			if (ReferenceEquals(e, null)) return;

			try
			{
				// 
				// Ώۂ̐}`.
				// 
				int iGripPosition = 0;
				FVIL.GDI.CFviGdiFigure figure = null;

				// ViewNCAg̈ł̍W.
				// Scaling = true ̎́A摜Wɕϊ.
				FVIL.Data.CFviPoint position = (Scaling)
					? DPtoIP(e.Location, ScalingMode)
					: new FVIL.Data.CFviPoint(e.Location);

				#region z̖(y̑O)珈.
				for (int i = Figures.Count - 1; i >= 0; i--)
				{
					figure = Figures[i];
					if (m_MouseInfo.bGrip == true)
					{
						if (ReferenceEquals(figure, m_MouseInfo.figure))
						{
							iGripPosition = m_MouseInfo.iGripPosition;
							break;
						}
					}
					else if(figure.Enable)
					{
						double margin = (Scaling) ? 4 / Magnification : 4;
						int status = figure.CheckFocusMarkPosition(position, margin);
						if (status != 0)
						{
							iGripPosition = status;
							break;
						}
					}
				}
				#endregion

				#region J[\`̕ύX.
				//     AllowChange ́ÃI[oC̃J[\ύXƊȂ悤ɂׂ̃tOł.
				//      AllowChange  false ̎́ÃI[oCł̃J[\ύXs܂B
				//     AllowChange  true ̎AJ[\`̕ύXs܂B
				//     J[\ύXAAllowChange  false ɕύX܂B

				// J[\ύX.
				if (iGripPosition != 0)
				{
					if (figure is IFigureHandling)
					{
						((WIL.GDI.IFigureHandling)figure).ChangeCursor(sender, e, iGripPosition);
					}
					else
					{
						// ̊ȗׁ̈A\J[\݂̂ɂĂ܂,
						// ObvʒuɂČ`ύXƎoIɕ₷Ȃ܂.
						((System.Windows.Forms.Control)sender).Cursor = System.Windows.Forms.Cursors.SizeAll;
					}

					// ȍ~AύXȂ.
					AllowChange = false;
				}
				#endregion
			}
			catch( System.Exception )
			{
			}
			return;
		}

		/// <summary>
		/// L[{[hCxg (L[)
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		protected virtual void OnKeyDown(object sender, KeyEventArgs e)
		{
			m_KeyboardInfo.IsDown = true;
			m_KeyboardInfo.Alt = e.Alt;
			m_KeyboardInfo.Control = e.Control;
			m_KeyboardInfo.Shift = e.Shift;
			m_KeyboardInfo.KeyCode = e.KeyCode;
			m_KeyboardInfo.KeyData = e.KeyData;
			m_KeyboardInfo.KeyValue = e.KeyValue;
		}

		/// <summary>
		/// L[{[hCxg (L[𗣂)
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		protected virtual void OnKeyUp(object sender, KeyEventArgs e)
		{
			m_KeyboardInfo.IsDown = false;
		}

		/// <summary>
		/// L[{[hCxg (L[)
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		protected virtual void OnPreviewKeyDown(object sender, System.Windows.Forms.PreviewKeyDownEventArgs e)
		{
		}

		/// <summary>
		/// }EX{^ꂽ̏
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		protected virtual void OnMouseDown(System.Object sender, System.Windows.Forms.MouseEventArgs e)
		{
		}

		/// <summary>
		/// }EX{^ꂽ̏
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		protected virtual void OnMouseUp(System.Object sender, System.Windows.Forms.MouseEventArgs e)
		{
			m_MouseInfo.bGrip = false;
		}

		/// <summary>
		/// }EXJ[\ړĂ鎞̏
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		protected virtual void OnMouseMove(System.Object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if( Active == false ) return;

			if( m_MouseInfo.bGrip )
			{
				// ViewNCAg̈ł̍W.
				// Scaling = true ̎́A摜Wɕϊ.
				FVIL.Data.CFviPoint current = (Scaling)
					? DPtoIP(e.Location, ScalingMode)
					: new FVIL.Data.CFviPoint(e.Location);

				FVIL.GDI.CFviGdiFigure figure = m_MouseInfo.figure;

				// }`̑.
				HandlingFigure(m_MouseInfo.figure, current, m_MouseInfo, m_KeyboardInfo);

				((System.Windows.Forms.Control)sender).Refresh();
			}
		}

		/// <summary>
		/// }EXJ[\ꂽ̏
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		protected virtual void OnMouseLeave( System.Object sender, System.EventArgs e )
		{
			m_MouseInfo.bGrip = false;
		}

		/// <summary>
		/// }EX̏L
		/// </summary>
		/// <param name="info">}EX̏</param>
		/// <returns>
		///		ύXꍇ true Ԃ܂BȊO false Ԃ܂B
		/// </returns>
		/// <remarks>
		///		}`̍W]ĂꍇɁAOڋ`̃}EXObvʒu]܂B
		///		Oڋ`ɂĕό`s}`ΏۂłB
		///		̃\bh́A}EXObvɈxĂяo悤ɂĂB
		/// </remarks>
		protected virtual bool Validate(ref MouseInfo info)
		{
			if (ReferenceEquals(info.figure, null)) return false;
			if (info.iGripPosition == 0) return false;

			bool bReverseH = false;	// ].
			bool bReverseV = false;	// ].

			#region Ώۂ̐}`.
			if (info.figure is FVIL.GDI.CFviGdiCircle)
			{
				FVIL.GDI.CFviGdiCircle figure = (FVIL.GDI.CFviGdiCircle)info.figure;
				bReverseH = (figure.Radius < 0);
				bReverseV = (figure.Radius < 0);
			}
			else if (info.figure is FVIL.GDI.CFviGdiEllipse)
			{
				FVIL.GDI.CFviGdiEllipse figure = (FVIL.GDI.CFviGdiEllipse)info.figure;
				bReverseH = (figure.AxisX < 0);
				bReverseV = (figure.AxisY < 0);
			}
			else if (info.figure is FVIL.GDI.CFviGdiRectangle)
			{
				FVIL.GDI.CFviGdiRectangle figure = (FVIL.GDI.CFviGdiRectangle)info.figure;
				bReverseH = (figure.Width < 0);
				bReverseV = (figure.Height < 0);
			}
			else
			{
				return false;
			}
			#endregion

			#region Oڋ`̈ʒu.
			FVIL.GDI.RectPosition rectpos = (FVIL.GDI.RectPosition)info.iGripPosition;
			bool L = ((rectpos & FVIL.GDI.RectPosition.Left) == FVIL.GDI.RectPosition.Left);
			bool R = ((rectpos & FVIL.GDI.RectPosition.Right) == FVIL.GDI.RectPosition.Right);
			bool T = ((rectpos & FVIL.GDI.RectPosition.Top) == FVIL.GDI.RectPosition.Top);
			bool B = ((rectpos & FVIL.GDI.RectPosition.Bottom) == FVIL.GDI.RectPosition.Bottom);
			#endregion

			#region ].
			if (bReverseH)
			{
				if (L && !R)	// ݁A ON ̎A OFF ĉE ON .
				{
					rectpos &= ~FVIL.GDI.RectPosition.Left;
					rectpos |= FVIL.GDI.RectPosition.Right;
				}
				if (R && !L)	// ݁AE ON ̎AE OFF č ON .
				{
					rectpos &= ~FVIL.GDI.RectPosition.Right;
					rectpos |= FVIL.GDI.RectPosition.Left;
				}
			}
			#endregion

			#region ].
			if (bReverseV)
			{
				if (T && !B)	// ݁Aオ ON ̎A OFF ĉ ON .
				{
					rectpos &= ~FVIL.GDI.RectPosition.Top;
					rectpos |= FVIL.GDI.RectPosition.Bottom;
				}
				if (B && !T)	// ݁A ON ̎A OFF ď ON .
				{
					rectpos &= ~FVIL.GDI.RectPosition.Bottom;
					rectpos |= FVIL.GDI.RectPosition.Top;
				}
			}
			#endregion

			// f.
			info.iGripPosition = (int)rectpos;

			return (bReverseH || bReverseV);
		}

		/// <summary>
		/// }`̑ ()
		/// </summary>
		/// <param name="figure">}`</param>
		/// <param name="current">݂̃}EXʒu</param>
		/// <param name="info">{^̏</param>
		/// <param name="key">{^̃L[{[h</param>
		/// <returns>
		///		}`̑삪sꂽꍇ true Ԃ܂B
		///		sȂꍇ false Ԃ܂B
		/// </returns>
		protected virtual bool HandlingFigure(FVIL.GDI.CFviGdiFigure figure, FVIL.Data.CFviPoint current, MouseInfo info, KeyboardInfo key)
		{
			if (info.iGripPosition == 0) return false;

			FigureHandlingMode mode = HandlingMode;

			#region [h̐؂ւ.
			if (key.IsDown &&
				key.Control == false &&
				key.Alt == true &&
				key.Shift == false)
			{
				// ALT ĂƂ.
				if (mode == FigureHandlingMode.Normal)
					mode = FigureHandlingMode.Rotate;
				else if (mode == FigureHandlingMode.Rotate)
					mode = FigureHandlingMode.Normal;
			}

			// ]̋֎~.
			if (!EnableRotate &&
				mode == FigureHandlingMode.Rotate)
				mode = FigureHandlingMode.Normal;
			#endregion

			if (mode == FigureHandlingMode.Rotate)
			{
				// }`̉].
				return RotateFigure(figure, current, info, key);
			}
			else
			{
				#region }`̕ό`܂͈ړ.

				if (!EnableModify)	// ό`̋֎~.
				{
					return MoveFigure(figure, current, info, key);
				}
				else if (figure is IFigureHandling)
				{
					bool status = ((WIL.GDI.IFigureHandling)figure).ModifyFigure(current, info, key);
					if (!status)
						status = MoveFigure(figure, current, info, key);
					return status;
				}
				else if (figure is FVIL.GDI.CFviGdiPoint)
				{
					return ModifyFigure((FVIL.GDI.CFviGdiPoint)figure, current, info, key);
				}
				else if (figure is FVIL.GDI.CFviGdiAnchor)
				{
					return ModifyFigure((FVIL.GDI.CFviGdiAnchor)figure, current, info, key);
				}
				else if (figure is FVIL.GDI.CFviGdiLine)
				{
					return ModifyFigure((FVIL.GDI.CFviGdiLine)figure, current, info, key);
				}
				else if (figure is FVIL.GDI.CFviGdiLineSegment)
				{
					return ModifyFigure((FVIL.GDI.CFviGdiLineSegment)figure, current, info, key);
				}
				else if (figure is FVIL.GDI.CFviGdiCircle)
				{
					return ModifyFigure((FVIL.GDI.CFviGdiCircle)figure, current, info, key);
				}
				else if (figure is FVIL.GDI.CFviGdiEllipse)
				{
					return ModifyFigure((FVIL.GDI.CFviGdiEllipse)figure, current, info, key);
				}
				else if (figure is FVIL.GDI.CFviGdiRectangle)
				{
					return ModifyFigure((FVIL.GDI.CFviGdiRectangle)figure, current, info, key);
				}
				else if (figure is FVIL.GDI.CFviGdiPolyline)
				{
					return ModifyFigure((FVIL.GDI.CFviGdiPolyline)figure, current, info, key);
				}
				else if (figure is FVIL.GDI.CFviGdiImage)
				{
					return ModifyFigure((FVIL.GDI.CFviGdiImage)figure, current, info, key);
				}
				else if (figure is FVIL.GDI.CFviGdiString)
				{
					return ModifyFigure((FVIL.GDI.CFviGdiString)figure, current, info, key);
				}
				else
				{
					// m̐}`͈ړ̂.
					return MoveFigure(figure, current, info, key);
				}

				#endregion
			}
		}

		/// <summary>
		/// }`̉] (ėp)
		/// </summary>
		/// <param name="figure">}`</param>
		/// <param name="current">݂̃}EXʒu</param>
		/// <param name="info">{^̏</param>
		/// <param name="key">{^̃L[{[h</param>
		/// <returns>
		///		}`̑삪sꂽꍇ true Ԃ܂B
		///		sȂꍇ false Ԃ܂B
		/// </returns>
		protected virtual bool RotateFigure(FVIL.GDI.CFviGdiFigure figure, FVIL.Data.CFviPoint current, MouseInfo info, KeyboardInfo key)
		{
			if (info.iGripPosition == 0) return false;

			FVIL.Data.CFviAngle st = WIL.Math.Angle(info.mouse, WIL.Math.Add(figure.Position, figure.Axis));
			FVIL.Data.CFviAngle ed = WIL.Math.Angle(current, WIL.Math.Add(figure.Position, figure.Axis));

			// {^̈ړʂvZ.
			FVIL.Data.CFviAngle move = WIL.Math.Sub(ed, st);

			// }`].
			figure.Angle = WIL.Math.Add(info.angle, move);

			return true;
		}

		/// <summary>
		/// }`̈ړ (ėp)
		/// </summary>
		/// <param name="figure">}`</param>
		/// <param name="current">݂̃}EXʒu</param>
		/// <param name="info">{^̏</param>
		/// <param name="key">{^̃L[{[h</param>
		/// <returns>
		///		}`̑삪sꂽꍇ true Ԃ܂B
		///		sȂꍇ false Ԃ܂B
		/// </returns>
		protected virtual bool MoveFigure(FVIL.GDI.CFviGdiFigure figure, FVIL.Data.CFviPoint current, MouseInfo info, KeyboardInfo key)
		{
			if (info.iGripPosition == 0) return false;
			if (!EnableMove) return false;

			// {^̈ړʂvZ.
			FVIL.Data.CFviPoint move = WIL.Math.Sub(current, info.mouse);

			// }`ړ.
			figure.Position = WIL.Math.Add(info.position, move);

			return true;
		}

		#region }`̕ό`.

		/// <summary>
		/// }`̕ό` (_)
		/// </summary>
		/// <param name="figure">}`</param>
		/// <param name="current">݂̃}EXʒu</param>
		/// <param name="info">{^̏</param>
		/// <param name="key">{^̃L[{[h</param>
		/// <returns>
		///		}`̑삪sꂽꍇ true Ԃ܂B
		///		sȂꍇ false Ԃ܂B
		/// </returns>
		protected virtual bool ModifyFigure(FVIL.GDI.CFviGdiPoint figure, FVIL.Data.CFviPoint current, MouseInfo info, KeyboardInfo key)
		{
			if (info.iGripPosition == 0) return false;

			#region }`ړ.

			if (info.iGripPosition != 0)
				return MoveFigure(figure, current, info, key);

			#endregion

			return false;
		}

		/// <summary>
		/// }`̕ό` (AJ[)
		/// </summary>
		/// <param name="figure">}`</param>
		/// <param name="current">݂̃}EXʒu</param>
		/// <param name="info">{^̏</param>
		/// <param name="key">{^̃L[{[h</param>
		/// <returns>
		///		}`̑삪sꂽꍇ true Ԃ܂B
		///		sȂꍇ false Ԃ܂B
		/// </returns>
		protected virtual bool ModifyFigure(FVIL.GDI.CFviGdiAnchor figure, FVIL.Data.CFviPoint current, MouseInfo info, KeyboardInfo key)
		{
			if (info.iGripPosition == 0) return false;

			#region }`ړ.
			if (info.iGripPosition != 0)
				return MoveFigure(figure, current, info, key);
			#endregion

			#region }`̕ό`.

			// }EX̏ōWvZ.
			FVIL.Data.CFviPoint axis = WIL.Math.Add(info.position, info.axis);
			FVIL.Data.CFviAngle angle = WIL.Math.Invert(info.angle);
			FVIL.Data.CFviPoint pos = FVIL.Math.Rotate(current, axis, angle);

			if (info.iGripPosition == 1)			// n_.
			{
				figure.St = pos;
			}
			else if (info.iGripPosition == 2)		// I_.
			{
				figure.Ed = pos;
			}

			// --- @̕␳.
			if (angle.Degree != 0.0)
				figure.Axis = WIL.Math.Sub(axis, figure.Position);

			#endregion

			return true;
		}

		/// <summary>
		/// }`̕ό` ()
		/// </summary>
		/// <param name="figure">}`</param>
		/// <param name="current">݂̃}EXʒu</param>
		/// <param name="info">{^̏</param>
		/// <param name="key">{^̃L[{[h</param>
		/// <returns>
		///		}`̑삪sꂽꍇ true Ԃ܂B
		///		sȂꍇ false Ԃ܂B
		/// </returns>
		protected virtual bool ModifyFigure(FVIL.GDI.CFviGdiLine figure, FVIL.Data.CFviPoint current, MouseInfo info, KeyboardInfo key)
		{
			if (info.iGripPosition == 0) return false;

			#region }`ړ.
			if (info.iGripPosition < 0)
				return MoveFigure(figure, current, info, key);
			#endregion

			#region }`̕ό`.

			// }EX̏ōWvZ.
			FVIL.Data.CFviPoint axis = WIL.Math.Add(info.position, info.axis);
			FVIL.Data.CFviAngle angle = WIL.Math.Invert(info.angle);
			FVIL.Data.CFviPoint pos = FVIL.Math.Rotate(current, axis, angle);

			// ̎n_ƏI_ GetClipRect 擾ł܂AXlKv܂.
			FVIL.Data.CFviLineSegment ls = new FVIL.Data.CFviLineSegment(info.clip.St, info.clip.Ed);
			if (info.position != info.clip.St)	// n_łȂ.
			{
				ls.SX = info.clip.St.X;
				ls.SY = info.clip.Ed.Y; 
				ls.EX = info.clip.Ed.X;
				ls.EY = info.clip.St.Y;
			}

			// }`̕ό`.
			if (info.iGripPosition == 1)			// n_.
			{
				ls.St = pos;
				figure.CopyFrom(ls.ToCFviLine());
			}
			else if (info.iGripPosition == 2)		// I_.
			{
				ls.Ed = pos;
				figure.CopyFrom(ls.ToCFviLine());
			}

			// --- @̕␳.
			//      Size ɂĎn_ƏI_ύX邽߁A@̕␳͂ł܂.
			if (angle.Degree != 0.0)
			    figure.Axis = WIL.Math.Sub(axis, figure.Position);

			#endregion

			return true;
		}

		/// <summary>
		/// }`̕ό` ()
		/// </summary>
		/// <param name="figure">}`</param>
		/// <param name="current">݂̃}EXʒu</param>
		/// <param name="info">{^̏</param>
		/// <param name="key">{^̃L[{[h</param>
		/// <returns>
		///		}`̑삪sꂽꍇ true Ԃ܂B
		///		sȂꍇ false Ԃ܂B
		/// </returns>
		protected virtual bool ModifyFigure(FVIL.GDI.CFviGdiLineSegment figure, FVIL.Data.CFviPoint current, MouseInfo info, KeyboardInfo key)
		{
			if (info.iGripPosition == 0) return false;

			#region }`ړ.
			if (info.iGripPosition < 0)
				return MoveFigure(figure, current, info, key);
			#endregion

			#region }`̕ό`.

			// }EX̏ōWvZ.
			FVIL.Data.CFviPoint axis = WIL.Math.Add(info.position, info.axis);
			FVIL.Data.CFviAngle angle = WIL.Math.Invert(info.angle);
			FVIL.Data.CFviPoint pos = FVIL.Math.Rotate(current, axis, angle);

			// }`̕ό`.
			if (info.iGripPosition == 1)			// n_.
			{
				figure.St = pos;
			}
			else if (info.iGripPosition == 2)		// I_.
			{
				figure.Ed = pos;
			}

			// --- @̕␳.
			if( angle.Degree != 0.0 )
				figure.Axis = WIL.Math.Sub(axis, figure.Position);

			#endregion

			return true;
		}

		/// <summary>
		/// }`̕ό` (^~)
		/// </summary>
		/// <param name="figure">}`</param>
		/// <param name="current">݂̃}EXʒu</param>
		/// <param name="info">{^̏</param>
		/// <param name="key">{^̃L[{[h</param>
		/// <returns>
		///		}`̑삪sꂽꍇ true Ԃ܂B
		///		sȂꍇ false Ԃ܂B
		/// </returns>
		protected virtual bool ModifyFigure(FVIL.GDI.CFviGdiCircle figure, FVIL.Data.CFviPoint current, MouseInfo info, KeyboardInfo key)
		{
			if (info.iGripPosition == 0) return false;

			#region }`ړ.
			FVIL.GDI.RectPosition rectpos = (FVIL.GDI.RectPosition)info.iGripPosition;
			if ((rectpos & FVIL.GDI.RectPosition.ALL) == FVIL.GDI.RectPosition.ALL)
				return MoveFigure(figure, current, info, key);
			#endregion

			#region }`̕ό`.

			// }EX̏ōWvZ.
			FVIL.Data.CFviPoint axis = WIL.Math.Add(info.position, info.axis);
			FVIL.Data.CFviAngle angle = WIL.Math.Invert(info.angle);
			FVIL.Data.CFviPoint mouse = FVIL.Math.Rotate(info.mouse, axis, angle);
			FVIL.Data.CFviPoint pos = FVIL.Math.Rotate(current, axis, angle);
			FVIL.Data.CFviPoint move = WIL.Math.Sub(pos, mouse);

			// }`̕ό`.
			bool L = ((rectpos & FVIL.GDI.RectPosition.Left) == FVIL.GDI.RectPosition.Left);
			bool R = ((rectpos & FVIL.GDI.RectPosition.Right) == FVIL.GDI.RectPosition.Right);
			bool T = ((rectpos & FVIL.GDI.RectPosition.Top) == FVIL.GDI.RectPosition.Top);
			bool B = ((rectpos & FVIL.GDI.RectPosition.Bottom) == FVIL.GDI.RectPosition.Bottom);

			FVIL.Data.CFviRectangle clip = figure.GetClipRect();

			if (L && T)
			{
				clip.Left = (mouse.X + move.X);
				clip.Top = (mouse.Y + move.X);
			}
			else if (L && B)
			{
				clip.Left = (mouse.X + move.X);
				clip.Bottom = (mouse.Y - move.X);
			}
			else if (R && T)
			{
				clip.Right = (mouse.X + move.X);
				clip.Top = (mouse.Y - move.X);
			}
			else if (R && B)
			{
				clip.Right = (mouse.X + move.X);
				clip.Bottom = (mouse.Y + move.X);
			}
			else if (L)
			{
				clip.Left = (mouse.X + move.X);
				clip.Top += move.X / 2;
				clip.Bottom -= move.X / 2;
			}
			else if (R)
			{
				clip.Right = (mouse.X + move.X);
				clip.Top -= move.X / 2;
				clip.Bottom += move.X / 2;
			}
			else if (T)
			{
				clip.Top = (mouse.Y + move.Y);
				clip.Left += move.Y / 2;
				clip.Right -= move.Y / 2;
			}
			else if (B)
			{
				clip.Bottom = (mouse.Y + move.Y);
				clip.Left -= move.Y / 2;
				clip.Right += move.Y / 2;
			}

			double radius_x = clip.Width / 2;
			double radius_y = clip.Height / 2;

			figure.X = clip.X + radius_x;
			figure.Y = clip.Y + radius_y;

			if (L || R)
			{
				figure.Radius = clip.Width / 2;
			}
			else
			{
				figure.Radius = clip.Height / 2;
			}

			// --- @̕␳.
			if (angle.Degree != 0.0)
				figure.Axis = WIL.Math.Sub(axis, figure.Position);

			#endregion

			return true;
		}

		/// <summary>
		/// }`̕ό` (ȉ~)
		/// </summary>
		/// <param name="figure">}`</param>
		/// <param name="current">݂̃}EXʒu</param>
		/// <param name="info">{^̏</param>
		/// <param name="key">{^̃L[{[h</param>
		/// <returns>
		///		}`̑삪sꂽꍇ true Ԃ܂B
		///		sȂꍇ false Ԃ܂B
		/// </returns>
		protected virtual bool ModifyFigure(FVIL.GDI.CFviGdiEllipse figure, FVIL.Data.CFviPoint current, MouseInfo info, KeyboardInfo key)
		{
			if (info.iGripPosition == 0) return false;

			#region }`ړ.
			FVIL.GDI.RectPosition rectpos = (FVIL.GDI.RectPosition)info.iGripPosition;
			if ((rectpos & FVIL.GDI.RectPosition.ALL) == FVIL.GDI.RectPosition.ALL)
				return MoveFigure(figure, current, info, key);
			#endregion

			#region }`̕ό`.

			// }EX̏ōWvZ.
			FVIL.Data.CFviPoint axis = WIL.Math.Add(info.position, info.axis);
			FVIL.Data.CFviAngle angle = WIL.Math.Invert(info.angle);
			FVIL.Data.CFviPoint pos = FVIL.Math.Rotate(current, axis, angle);

			// }`̕ό`.
			FVIL.Data.CFviRectangle clip = figure.GetClipRect();

			if ((rectpos & FVIL.GDI.RectPosition.Left) == FVIL.GDI.RectPosition.Left)
			{
				clip.Left = pos.X;
			}
			if ((rectpos & FVIL.GDI.RectPosition.Right) == FVIL.GDI.RectPosition.Right)
			{
				clip.Right = pos.X;
			}
			if ((rectpos & FVIL.GDI.RectPosition.Top) == FVIL.GDI.RectPosition.Top)
			{
				clip.Top = pos.Y;
			}
			if ((rectpos & FVIL.GDI.RectPosition.Bottom) == FVIL.GDI.RectPosition.Bottom)
			{
				clip.Bottom = pos.Y;
			}

			double radius_x = clip.Width / 2;
			double radius_y = clip.Height / 2;

			figure.X = clip.X + radius_x;
			figure.Y = clip.Y + radius_y;
			figure.AxisX = radius_x;
			figure.AxisY = radius_y;

			// --- @̕␳.
			if (angle.Degree != 0.0)
				figure.Axis = WIL.Math.Sub(axis, figure.Position);

			#endregion

			return true;
		}

		/// <summary>
		/// }`̕ό` (`)
		/// </summary>
		/// <param name="figure">}`</param>
		/// <param name="current">݂̃}EXʒu</param>
		/// <param name="info">{^̏</param>
		/// <param name="key">{^̃L[{[h</param>
		/// <returns>
		///		}`̑삪sꂽꍇ true Ԃ܂B
		///		sȂꍇ false Ԃ܂B
		/// </returns>
		protected virtual bool ModifyFigure(FVIL.GDI.CFviGdiRectangle figure, FVIL.Data.CFviPoint current, MouseInfo info, KeyboardInfo key)
		{
			if (info.iGripPosition == 0) return false;

			#region }`ړ.
			FVIL.GDI.RectPosition rectpos = (FVIL.GDI.RectPosition)info.iGripPosition;
			if ((rectpos & FVIL.GDI.RectPosition.ALL) == FVIL.GDI.RectPosition.ALL)
				return MoveFigure(figure, current, info, key);
			#endregion

			#region }`̕ό`.

			// }EX̏ōWvZ.
			FVIL.Data.CFviPoint axis = WIL.Math.Add(info.position, info.axis);
			FVIL.Data.CFviAngle angle = WIL.Math.Invert(info.angle);
			FVIL.Data.CFviPoint pos = FVIL.Math.Rotate(current, axis, angle);

			// }`̕ό`.
			FVIL.Data.CFviRectangle clip = figure.GetClipRect();

			if ((rectpos & FVIL.GDI.RectPosition.Left) == FVIL.GDI.RectPosition.Left)
			{
				clip.Left = pos.X;
			}
			if ((rectpos & FVIL.GDI.RectPosition.Right) == FVIL.GDI.RectPosition.Right)
			{
				clip.Right = pos.X;
			}
			if ((rectpos & FVIL.GDI.RectPosition.Top) == FVIL.GDI.RectPosition.Top)
			{
				clip.Top = pos.Y;
			}
			if ((rectpos & FVIL.GDI.RectPosition.Bottom) == FVIL.GDI.RectPosition.Bottom)
			{
				clip.Bottom = pos.Y;
			}

			figure.Left = clip.Left;
			figure.Right = clip.Right;
			figure.Top = clip.Top;
			figure.Bottom = clip.Bottom;

			// --- @̕␳.
			if (angle.Degree != 0.0)
				figure.Axis = WIL.Math.Sub(axis, figure.Position);

			#endregion

			return true;
		}

		/// <summary>
		/// }`̕ό` (p`)
		/// </summary>
		/// <param name="figure">}`</param>
		/// <param name="current">݂̃}EXʒu</param>
		/// <param name="info">{^̏</param>
		/// <param name="key">{^̃L[{[h</param>
		/// <returns>
		///		}`̑삪sꂽꍇ true Ԃ܂B
		///		sȂꍇ false Ԃ܂B
		/// </returns>
		protected virtual bool ModifyFigure(FVIL.GDI.CFviGdiPolyline figure, FVIL.Data.CFviPoint current, MouseInfo info, KeyboardInfo key)
		{
			if (info.iGripPosition == 0) return false;

			if (figure.Close)
			{
				if (info.iGripPosition < 0)
				{
					// }`Ŝړ.
					return MoveFigure(figure, current, info, key);
				}
				else if (0 < info.iGripPosition && info.iGripPosition <= figure.Count)
				{
					#region }`̕ό`.
					// _ړāA}`ό`.
					figure.Close = false;
					ModifyFigure(figure, current, info, key);
					figure.Close = true;
					#endregion

					return true;
				}
			}
			else
			{
				// }EX̏ōWvZ.
				FVIL.Data.CFviPoint axis = WIL.Math.Add(info.position, info.axis);
				FVIL.Data.CFviAngle angle = WIL.Math.Invert(info.angle);
				FVIL.Data.CFviPoint pos = FVIL.Math.Rotate(current, axis, angle);

				if (info.iGripPosition < 0)
				{
					// }`Ŝړ.
					return MoveFigure(figure, current, info, key);
				}
				else if (0 < info.iGripPosition && info.iGripPosition <= figure.Count)
				{
					#region }`̕ό`.
					// _ړāA}`ό`.
					int index = info.iGripPosition - 1;
					figure[index] = pos;

					// --- @̕␳.
					if (angle.Degree != 0.0)
						figure.Axis = WIL.Math.Sub(axis, figure.Position);
					#endregion

					return true;
				}
			}

			return false;
		}

		/// <summary>
		/// }`̕ό` (摜)
		/// </summary>
		/// <param name="figure">}`</param>
		/// <param name="current">݂̃}EXʒu</param>
		/// <param name="info">{^̏</param>
		/// <param name="key">{^̃L[{[h</param>
		/// <returns>
		///		}`̑삪sꂽꍇ true Ԃ܂B
		///		sȂꍇ false Ԃ܂B
		/// </returns>
		protected virtual bool ModifyFigure(FVIL.GDI.CFviGdiImage figure, FVIL.Data.CFviPoint current, MouseInfo info, KeyboardInfo key)
		{
			if (info.iGripPosition == 0) return false;

			#region }`ړ.
			FVIL.GDI.RectPosition rectpos = (FVIL.GDI.RectPosition)info.iGripPosition;
			if ((rectpos & FVIL.GDI.RectPosition.ALL) == FVIL.GDI.RectPosition.ALL)
				return MoveFigure(figure, current, info, key);
			#endregion

			#region }`̕ό`.

			// }EX̏ōWvZ.
			FVIL.Data.CFviPoint axis = WIL.Math.Add(info.position, info.axis);
			FVIL.Data.CFviAngle angle = WIL.Math.Invert(info.angle);
			FVIL.Data.CFviPoint pos = FVIL.Math.Rotate(current, axis, angle);

			// }`̕ό`.
			FVIL.Data.CFviRectangle clip = figure.GetClipRect();

			if ((rectpos & FVIL.GDI.RectPosition.Left) == FVIL.GDI.RectPosition.Left)
			{
				clip.Left = pos.X;
			}
			if ((rectpos & FVIL.GDI.RectPosition.Right) == FVIL.GDI.RectPosition.Right)
			{
				clip.Right = pos.X;
			}
			if ((rectpos & FVIL.GDI.RectPosition.Top) == FVIL.GDI.RectPosition.Top)
			{
				clip.Top = pos.Y;
			}
			if ((rectpos & FVIL.GDI.RectPosition.Bottom) == FVIL.GDI.RectPosition.Bottom)
			{
				clip.Bottom = pos.Y;
			}

			if (!(clip.Left <= clip.Right))
			{
				double tmp = clip.Left;
				clip.Left = clip.Right;
				clip.Right = tmp;
			}
			if (!(clip.Top <= clip.Bottom))
			{
				double tmp = clip.Top;
				clip.Top = clip.Bottom;
				clip.Bottom = tmp;
			}

			figure.Position = new FVIL.Data.CFviPoint(clip.Left, clip.Top);
			int stretchH = FVIL.Math.Round(clip.Width);
			int stretchV = FVIL.Math.Round(clip.Height);
			figure.StretchHorzSize = (stretchH <= 0) ? 1 : stretchH;
			figure.StretchVertSize = (stretchV <= 0) ? 1 : stretchV;

			// --- @̕␳.
			if (angle.Degree != 0.0)
				figure.Axis = WIL.Math.Sub(axis, figure.Position);

			#endregion

			return true;
		}

		/// <summary>
		/// }`̕ό` ()
		/// </summary>
		/// <param name="figure">}`</param>
		/// <param name="current">݂̃}EXʒu</param>
		/// <param name="info">{^̏</param>
		/// <param name="key">{^̃L[{[h</param>
		/// <returns>
		///		}`̑삪sꂽꍇ true Ԃ܂B
		///		sȂꍇ false Ԃ܂B
		/// </returns>
		protected virtual bool ModifyFigure(FVIL.GDI.CFviGdiString figure, FVIL.Data.CFviPoint current, MouseInfo info, KeyboardInfo key)
		{
			if (info.iGripPosition == 0) return false;

			#region }`ړ.
			FVIL.GDI.RectPosition rectpos = (FVIL.GDI.RectPosition)info.iGripPosition;
			if ((rectpos & FVIL.GDI.RectPosition.ALL) == FVIL.GDI.RectPosition.ALL)
			{
				return MoveFigure(figure, current, info, key);
			}
			else if((rectpos & FVIL.GDI.RectPosition.Top) != FVIL.GDI.RectPosition.Top &&
					(rectpos & FVIL.GDI.RectPosition.Bottom) != FVIL.GDI.RectPosition.Bottom)
			{
				if ((rectpos & FVIL.GDI.RectPosition.Left) == FVIL.GDI.RectPosition.Left ||
					(rectpos & FVIL.GDI.RectPosition.Right) == FVIL.GDI.RectPosition.Right)
				{
					return MoveFigure(figure, current, info, key);
				}
			}
			#endregion

			#region }`̕ό`.

			// }EX̏ōWvZ.
			FVIL.Data.CFviPoint axis = WIL.Math.Add(info.position, info.axis);
			FVIL.Data.CFviAngle angle = WIL.Math.Invert(info.angle);
			FVIL.Data.CFviPoint pos = FVIL.Math.Rotate(current, axis, angle);

			// }`̕ό`.
			FVIL.Data.CFviRectangle clip = figure.GetClipRect();

			FVIL.GDI.TextAlign alignV = FVIL.GDI.TextAlign.Top;
			if ((figure.Align & FVIL.GDI.TextAlign.Bottom) == FVIL.GDI.TextAlign.Bottom)
				alignV = FVIL.GDI.TextAlign.Bottom;

			if ((rectpos & FVIL.GDI.RectPosition.Top) == FVIL.GDI.RectPosition.Top)
			{
				if (alignV == FVIL.GDI.TextAlign.Top)
				{
					return MoveFigure(figure, current, info, key);
				}
				clip.Top = pos.Y;
			}
			if ((rectpos & FVIL.GDI.RectPosition.Bottom) == FVIL.GDI.RectPosition.Bottom)
			{
				if (alignV == FVIL.GDI.TextAlign.Bottom)
				{
					return MoveFigure(figure, current, info, key);
				}
				clip.Bottom = pos.Y;
			}

			if (!(clip.Left <= clip.Right))
			{
				double tmp = clip.Left;
				clip.Left = clip.Right;
				clip.Right = tmp;
			}
			if (!(clip.Top <= clip.Bottom))
			{
				double tmp = clip.Top;
				clip.Top = clip.Bottom;
				clip.Bottom = tmp;
			}

			// --- tHg̍̂ݒ.( 0 (ɍœKȒl)Ƃ)
			int fontV = FVIL.Math.Round(clip.Height);
			fontV = (fontV <= 9) ? 9 : fontV;
			figure.Font.Size = new Size(0, fontV);

			// --- @̕␳.
			if (angle.Degree != 0.0)
				figure.Axis = WIL.Math.Sub(axis, figure.Position);

			#endregion

			return true;
		}

		#endregion
	}
}
